/* Algorithm by Donald Knuth. */
/* C implementation by Glenn C. Rhoads */

#include <stdio.h>
#include <stdlib.h>

#define ODD(x)  (x&1)


int main( void )
   {
   int i, k, n, r, *a, *w;

   printf( "Enter n k: " );
   scanf( "%d %d", &n, &k );

   a = malloc( n * sizeof( int ) );
   w = malloc( (n+1) * sizeof( int ) );
   r = n-k;

   for (i=0; i < r; i++) { a[i] = 0; w[i] = 1; }
   for (i=r; i < n; i++) { a[i] = 1; w[i] = 1; }

   w[n] = 1;


   for (;;)
      {
      for (i = n-1; i >= 0; i--) printf( "%3d", a[i] );
      printf( "\n" );

      for (i=r; w[i] == 0; i++) w[i] = 1;
      if (i == n) exit(0);
      w[i] = 0;

      if (a[i] != 0)
         {
         a[i] = 0;
         if (ODD(i) || a[i-2] != 0)
            {
            a[i-1] = 1;
            if (r == i-1) r = i;
            else if (r == i && i > 1) r = i-1;
            }
         else
            {
            a[i-2] = 1;
            if (r == i-2) r = i-1;
            else if (r == i)
               {
               if (i > 3) r = i-2;
               else r = 1;
               }
            }
         }
      else
         {
         a[i] = 1;
         if (ODD(i) && a[i-1] == 0)
            {
            a[i-2] = 0;
            if (r == i-2) r = i;
            else if (r == i-1) r = i-2;
            }
         else
            {
            a[i-1] = 0;
            if (r == i-1) r = i;
            else if (r == i && i > 1) r = i-1;
            }
         }
      }

   return 0;
   }
