#include <stdio.h>
#include <stdlib.h>
#define MAXN 200
int combinNb = 0;
int p[MAXN];
char *colors[]={"red","green","blue","white"};
void listCombin(int k, int p[])
{
    printf("%3d: ", ++combinNb);
    for (int i=1; i<=k; i++)
        printf("%s ", colors[p[i]-1]);
    printf("\n");
}
void combinRec(int n, int k, int i)
{
    int j;
    for (j = p[i-1]+1; j <= n-k+i; j++)
    {
        p[i] = j;
        if (i < k) combinRec(n, k, i+1);
        else
        {
            listCombin(k, p);
        }
    }
}

void combinNonRec(int n, int k)
{
    int p[MAXN];
    int i, j, combinNb;
    for (i=1; i <=k; i++) p[i]=i; /* first combination */
    listCombin(k, p);
    i = k;
    while (i > 0) /* generate the next combinations */
    {
        p[i]++; // find index satisfying relation set
        if (p[i] > n - k + i) i--;
        else
        {
            for (j = i + 1; j <= k; j++) p[j]=p[j-1] + 1;
            combinNb++;
            listCombin(k, p);
            i = k;
        }
    }
}

int main()
{
    printf("Combinations generation, non-recursive:\n");
    combinNonRec(4, 2);
    printf("Combinations generation, recursive:\n");
    combinNb = 0;
    for (int i=1; i <=2; i++) p[i]=i;
    combinRec(4, 2, 1);
    return 0;
}
