#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#define MAXN 100
int setNb, p[MAXN];

void listSet(int n, int setNb)
{
	int i;

  printf("\n%3d { ", setNb);
	for (i = 1; i <=n; i++)
		if (p[i] == 1 ) printf(" %2d,", i);
	printf("\b  }");
}
void allSubsetsNR(int n)
{
	int i, setNb; // p[i]=1 if element i is a member, 					    // i.e p is a characteristic vector
	setNb=1;
	for (i=1; i<=n; i++) p[i]=0; /*empty set */
	listSet(n, setNb);
	for (i=n; i>0; ) /* generate next subsets */
	{
		if (p[i] == 0)
		{
			p[i] = 1;
			setNb++;
			listSet(n, setNb);
			i = n;
		}
		else
		{
			p[i] = 0;
			i--;
		}
	}
}

void allSubsetsRec(int n, int i)
{
	int j;
	for (j=0; j <= 1; j++)
	{
		p[i] = j;
		if (i < n) allSubsetsRec(n, i+1);
		else
		{
			setNb++;
			listSet(n, setNb);
		}
	}
}

int main(int argc, char**argv)
{
    printf("Power set, recursive geneartion\n");
	allSubsetsRec(5, 1);
    printf("\nPower set, non-recursive geneartion\n");
	allSubsetsNR(5);
	return 0;
}

