/* Algorithm by Donald Knuth. */
/* C implementation by Glenn C. Rhoads */

#include <stdio.h>
#include <stdlib.h>

void main( void)
{
    int i, j=1, k, n, *c;

    printf( "Enter n,k: ");
    scanf( "%d,%d", &n, &k);

    c = malloc( (k+3) * sizeof(int));
    
    for (i=1; i <= k; i++) c[i] = i;
    c[k+1] = n+1;
    j = k;

 visit:
    for (i=k; i >= 1; i--) printf( "%3d", c[i]);
    printf( "\n");

    if (k&1)
       {
       if (c[1] + 1 < c[2]) {c[1] += 1; goto visit;}
       else j = 2;
       }
    else
       {
       if (c[1] > 1) {c[1] -= 1; goto visit;}
       else j = 2;
       goto R5;
       }

 R4:
    if (c[j] >= j+1)
       {
       c[j] = c[j-1];
       c[j-1] = j-1;
       goto visit;
       }
    j++;

 R5:
    if (c[j]+1 < c[j+1])
       {
       c[j-1] = c[j];
       c[j] += 1;
       goto visit;
       }
    j++;
    if (j <= k) goto R4;
}
