#include <stdio.h>
#include <stdlib.h>
#define MAX_COMB 200
#define MAX_PERM 200
int p[MAX_COMB], v[MAX_PERM];
int arrNb, n, m;
// swap 2 integers
void swap(int *i, int *j)
{
	int temp;
	temp = *i;
 	*i = *j;
	*j = temp;
}
// revert array area
void revert(int i, int n, int k)
{
	int j;
	for (j = 1; j <= k; j++)
	  swap(&v[i+j], &v[n+1-j]);
}
// list arrangements
void listArrang(int nb, int p[])
{
    printf("%3d: ", arrNb);
    for (int i=1; i <= nb; i++)
        printf("%3d ", p[i]);
    printf("\n");
}
// generate arrangements of n taken m
void arrange(int n, int m, int i)
{
    int j, k, r;
    for (j = p[i-1] + 1; j <= n - m + i; j++)   // recursively generate combinations
    {
        p[i] = j;
        if (i < m) arrange(n, m, i + 1);
        else
        {
            arrNb++;
            listArrang(m, p);

            for (k = 1; k <= m; k++) v[k] = p[k]; // save combination
            do   // nonrecursively permute combination
            {
                k = m - 1;
                while (v[k] > v[k + 1] && k > 0) k--;
                if (k > 0)
                {
                    for (r = m; v[k] > v[r]; r--);
                    swap(&v[k], &v[r]);
                    revert(k, m, (m - k) / 2);
                    arrNb++;
                    listArrang(m, v);
                }
            }
            while (k > 0);
        }
    }
}
int main()
{
    arrange(5, 3, 1);
    return 0;
}
